package params

import (
	"nexus-common/vm"
	"nexus-common/caps"
	"github.com/google/uuid"
)

type VMCreate struct {
	Name string           `json:"name"       validate:"required,min=1,max=256"`
	Cpus int              `json:"cpus"       validate:"required,gte=1,lte=32"`
	Ram int               `json:"ram"        validate:"required,gte=128,lte=32768"`
	Nic vm.NicType        `json:"nic"        validate:"required`
	UsbDevs []string      `json:"usbDevs"    validate:"required`
	TemplateID uuid.UUID  `json:"templateID" validate:"required"`
}

type VMStartWithCreds struct {
	Port int              `json:"port"       validate:"required,gte=1025,lte=65535"`
	Pwd string            `json:"pwd"        validate:"required,min=8,max=64"`
}

type VMEdit struct {
	Name string           `json:"name"       validate:"required,min=1,max=256"`
	Cpus int              `json:"cpus"       validate:"required,gte=1,lte=32"`
	Ram int               `json:"ram"        validate:"required,gte=128,lte=32768"`
	Nic vm.NicType        `json:"nic"        validate:"required`
	UsbDevs []string      `json:"usbDevs"    validate:"required`
}

type VMAddAccess struct {
	Access caps.Capabilities  `json:"access"  validate:"required"`
}

type VMExportDir struct {
	Dir string  `json:"dir"`
}
